package pl.edu.amu.andrzej.jurga;

import static org.junit.jupiter.api.Assertions.*;
import static org.assertj.core.api.Assertions.assertThat;

import org.junit.jupiter.api.Assertions;
import org.junit.jupiter.api.Test;
import org.junit.jupiter.params.ParameterizedTest;
import org.junit.jupiter.params.provider.CsvSource;
import static org.junit.jupiter.api.Assertions.*;
import org.junit.jupiter.params.provider.ValueSource;
import org.junit.jupiter.params.shadow.com.univocity.parsers.annotations.Validate;
import pl.edu.amu.andrzej.jurga.Prime;

import java.util.Arrays;
import java.util.List;
import java.util.stream.Collectors;
import java.util.stream.Stream;

class TestPrime {
    int[] testArray = Prime.primes(20);

    @Test
    public void shoudntBeNull(){
        org.assertj.core.api.Assertions.assertThat(testArray).isNotNull();
    }

    @Test
    public void checkPrimes(){
        org.assertj.core.api.Assertions.assertThat(testArray).containsExactlyInAnyOrder(2, 3, 5, 7, 11, 13, 17, 19);
    }

    @ParameterizedTest
    @CsvSource({
            "7, 2.3.5.7",
            "8, 2.3.5.7",
            "15, 2.3.5.7.11.13",
            "20, 2.3.5.7.11.13.17.19",
            "23, 2.3.5.7.11.13.17.19.23"
    })
    public void checkPrimesWithDifferentLimits(int a, String b){


                String[] splitArray = b.split("\\.");
                int[] tmp = new int[splitArray.length];

                for (int i = 0; i < splitArray.length; i++) {
                    tmp[i] = Integer.parseInt(splitArray[i]);
                }
            org.assertj.core.api.Assertions.assertThat(Prime.primes(a)).containsExactlyInAnyOrder(tmp);
    }

    @Test //zad 3
    public void testExpectedEXception(){
        assertThrows(IllegalArgumentException.class, () -> {
            Prime.primes(1);
        });
    }
}