from django.urls import path, re_path
from .views import ImportsView, CreateImportsView, MeView, UserCreate, DeleteImports, ExportXML, RenameImports, ExportJSON, ActivateImportsView
from rest_framework.routers import DefaultRouter
from rest_framework.authtoken import (views)


router = DefaultRouter()
urlpatterns = [
    path('register/', UserCreate.as_view(), name='account-create'),
    path('list/', ImportsView.as_view({'get': 'list'})),
    #path('update/<int:pk>', RenameImports.as_view({'put': 'update'}), name='update'),
    path('update/', RenameImports.as_view(), name='rename'),
    path('export/xml', ExportXML.as_view()),
    path('export/json/<int:import_id>', ExportJSON.as_view(), name='download'),
    path('delete/<int:import_id>', DeleteImports.as_view(), name='delete'),
    path('create/', CreateImportsView.as_view()),
    path('activate/', ActivateImportsView.as_view()),
    path('token/', views.obtain_auth_token, name='token_obtain_pair'),
    path('me/', MeView.as_view(), name='me'),
]

router = DefaultRouter()

urlpatterns += router.urls