import { createWebHistory, createRouter } from "vue-router";
import HomeView from "@/views/HomeView.vue";
import AboutView from "@/views/AboutView.vue";
import LoginView from "@/views/LoginView.vue";
import ImportListView from "@/views/ImportListView.vue";
import CreateImportView from "@/views/CreateImportView.vue";
import RegisterView from "@/views/RegisterView.vue";
import PaymentView from "@/views/PaymentView.vue";
import ServerView from "@/views/ServerView.vue";
import ActivateImportView from "@/views/ActivateImportView.vue";
import { userStore } from "../store/userStore.js";

const routes = [
  {
    path: "/",
    name: "Home",
    component: HomeView,
  },
  {
    path: "/about",
    name: "About",
    component: AboutView,
  },
  {
    path: "/login",
    name: "login",
    component: LoginView,
  },
  {
    path: "/list",
    name: "list",
    component: ImportListView,
  },
  {
    path: "/create",
    name: "create",
    component: CreateImportView,
  },
  {
    path: "/register",
    name: "register",
    component: RegisterView,
  },
  {
    path: "/payment",
    name: "payment",
    component: PaymentView,
  },
  {
    path: "/server",
    name: "server",
    component: ServerView,
  },
  {
    path: "/activate",
    name: "activate",
    component: ActivateImportView,
  },
];

const router = createRouter({
  history: createWebHistory(),
  routes,
});

router.beforeEach(async (to) => {
  const publicPages = ["/login", "/register"];
  const auth = userStore.userToken || null;
  const authRequired = !publicPages.includes(to.path);
  if (authRequired && !auth) {
    return "/login";
  }
});

export default router;
