import json
import xmltodict
import logging
import pytz
from datetime import datetime, timedelta
import xml.etree.ElementTree as elementTree

def isXml(value):
    try:
        elementTree.fromstring(value)
    except elementTree.ParseError:
        return False
    return True

def convertXML(file_name, creation_date, paid):
    if datetime.now(pytz.utc) - timedelta(days=1) > creation_date and paid == 0:
        return 402

    with open("./media/" + file_name) as xml_file:
        xml_var = xml_file.read()
        if isXml(xml_var) == False:
            return 400

        data_dict = xmltodict.parse(xml_var)
        xml_file.close()
        return json.dumps(data_dict)